
JUST (1L) 1 April 1993 JUST (1L)



NAME

just - ascii text justifier (version 1.03)

SYNOPSIS

just [ options ] [ file ... ]

DESCRIPTION

Just formats ascii text to a width  of  NNN  characters  in  left  (-l),
centre (-c), right (-r) or padded (-p) justification modes.

Empty lines and lines  starting  with  white  space,  backslash  (`\\'),
percent (`%')  or a dot  (`.'),  are  recognized  as  paragraph  breaks.
Trailing short lines are not padded.  Note that the utility  is  usually
used as a filter. The typical usage is as follows:

just < foo.ragged > foo.neat

but the input file name can also be specified on the command line:

just foo.ragged > foo.neat

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+ The -x option will cause justified paragraphs to be placed in a  box +
+ surround. Incoming boxes are stripped and repackaged.                +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

OPTIONS

The following options are available:

-wNNN  (Default  72).   Specify  the  desired  output  page  width,   in
characters.  If any single input word is longer than this by  more  than
about 250 characters, there will be trouble.

-mPPP (default 1).  Specify the line length  below  which  justification
should not be attempted.  In padding mode, this helps avoid output lines
with unsightly gaps caused by over-expansion of short lines.

-l Specify left justification mode. Words are packed left with one space
between each, to a maximum of NNN characters per line.

-c Specify centre justification mode.  Lines are packed to  centre  with
one space between each word, to a maximum of NNN characters per line.

-r Specify right justification mode.  Words are packed  right  with  one
space between each, to a maximum of NNN characters per line.

-p Specify padding justification mode.  Words are packed into  lines  of
length exactly NNN with at least one space between each.  Padding  takes
place preferentially at punctuation,  but there will be no more than one
space difference in spacing between all the words on any single line.

-xC Use character C to make a  box-surround  for  justified  paragraphs.
Incoming boxes are stripped and repackaged.  The margin  is  effectively
reduced by 2 chars (C and a space), and text indented by 2 chars.

-V Display the usage  of  the  command,  including  a  list  of  options
available.

-v Display the version number.

SEE ALSO

fill(1L), pos(1L), fmt(1)

AUTHOR

Peter Breuer, Programming Research Group, Oxford University, UK.

BUGS

This manual page may change without notice.

If one long word  occurs on a line,  there may be no space for the next.
In padding mode,  JUST breaks the line after the first long word, making
an improper short line. This should sometimes be avoidable (by inserting
more gaps in the previous line when there is one), but it's very rare.

Words longer than the stipulated line length are left as  single  lines.
An error ought to be flagged.

There is no flag to turn off recognition  of  leading  dots,  and  there
should be.

Long incoming top and bottom lines of boxes are not shortened on output.


HISTORY

 1993
 March 25, version 0.9 with -w option only.
 March 26, version 0.91  trailing  line  justification  suppressed,  i/o
           buffers separated and increased.
 April  2, version  1.0  added  all  justification  options  and dynamic
           buffer allocation with -b.
 April  3, version 1.01 added command line files and improved padding
           algorithm. Put trailing line  justification back into -r and
           -c modes.  Improved  error  messages.  Added -m minimal
           justification length functionality.
 April  4, version 1.02 added recognition of lines beginning with a  dot
           backslash or percent as paragraph breaks.  Cured bug flushing
           last line of file, and one in processing command line files.
 April  9, version 1.03 added boxing (-xC). Added -v and -V options to
           display version and usage without error return code. Improved
           justification algorithm again.
 April 13, version 1.04 improved justification efficiency across sweeps.

CONDITIONS

Free  for personal use.  Corporate users must register.  The source code
may not be repackaged unless these CONDITITIONS of use are attached.

SOURCE CODE

Included with the distribution, and available free from me by email.

REGISTRATION

For a $10 international money order I will send you a disk containing  a
version  with  right and center justification as well as left and padded
justification,  and will undertake to (make all reasonable attempts  to)
fix  problems  with  the code.  Updates will be notified to you and made
available by ftp or on disk. Email or mail me to make requests.

 Peter Breuer
 3 Arthur St.
 Cambridge CB4 3BX
 UK
 <ptb@comlab.ox.ac.uk>

