/* asc2wp v2.0 -- Gene Johannsen
 *  Pass 1:
 *	 Makes spacing between words single, removing all right justification.
 *	 Removes all spaces before and after a CR.
 *  Note:  To all you structured programming die-hards out there, this
 *         program uses gotos.  If you have a heart condition, go no further.
 *         (Actually its just a simple finite state machine, but they are
 *         still gotos)
 */

#include <stdio.h>

void pass_one(FILE *fp_in, FILE *fp_out)
{
int ch;

State0:
       if((ch=fgetc(fp_in))==EOF) goto HALT;
       if(ch=='\n') goto State0;
       else if(ch==' ') goto State0;
                   else goto State1;

State1:
       fputc(ch, fp_out);
       if((ch=fgetc(fp_in))==EOF) goto HALT;
       if(ch==' ')goto State2;
               else if (ch=='\n') goto State3;
               else goto State1;

State2:
       if((ch=fgetc(fp_in))==EOF) goto HALT;
       if(ch==' ')goto State2;
               else if (ch=='\n') goto State3;
               else goto State5;

State3:
       fputc('\n', fp_out);
       if ((ch=fgetc(fp_in)) == EOF) goto HALT;
       if (ch == ' ' || ch == '\t') goto State4;
               else if (ch=='\n') goto State3;
               else goto State1;

State4:
       if((ch=fgetc(fp_in))==EOF) goto HALT;
       if(ch=='\n') goto State3;
                   else if (ch==' ') goto State4;
                   else goto State1;

State5:
       fputc(' ', fp_out);
       fputc(ch, fp_out);
       if((ch=fgetc(fp_in))==EOF) goto HALT;
       if (ch==' ') goto State2;
                else if (ch=='\n') goto State3;
                else goto State1;

HALT:
     printf("Pass 1 done.\n");

}